% SYSTEM PARAMETERS

clear all;
close all;

% General Parameters

m = 36; % Total Mass in kg
P = 9.81*m/3; % Load per blade in N
nblades =3; % Number of blades

% Blade Parameters

    % Material Properties
    Material = 1; % 0 for 17-4 SSTL, 1 for 440C SSTL (204o Tempering T)
    if Material == 0
        SY = 1345E6; % Stress Yield 17-4 = 896-1379 MPa
        E = 197E9;% Young's Modulus 17-4 = 197E3 MPa
    elseif Material == 1
        SY = 1800E6; % Stress Yield 440C 
        E = 210E9;% Young's Modulus 440C 
    end

    % Design Values
    FoS = 3; % Factor of Safety
    f = 1.5; % Desired Frequency of the Blade in Hz
    

    
% Flexure Parameters

    %  Material: Music Wire Steel
    Ef = 2.01e11; % Young's Modulus in Pa
    SYf = 1.6e9; % Yield Strength in Pa

    % Factor of Safety
%    FoSf = 3; % FoS for the fixure

    % Geometry
    d = 0.61; %wire diameter in mm
    lf = 142.75; % Total length in mm
    
    % Tip displacement
    delta = 1/1000; % delta in m (1mm)
    
    
% Clamps Parameters

    % Material Properties (Screw)
    Material = 0; % 0 for 316 Stainless Steel+ Helicoils, 1 for 18-8 SSTL + Helicoils & 2 for 17-4 + Helicoils (Nitronic) 
    if Material == 0
        SYs = 334740000; % Yield Stress of the Screw in Pa
        mus = 0.5; % Friction coeficient 
    elseif Material == 1
        SYs = 448160000; % Yield Stress of the Screw in Pa
        mus = 0.5; % Friction coeficient 
    elseif Material == 2
        SYs = 861840000; % Yield Stress of the Screw in Pa
        mus = 0.5; % Friction coeficient 
    end

    %Screw
    %1/4-20
    ls = 1/20*0.0254; % Pitch of the Screw in m
    ds = 1/4*0.0254; %Screw diameter in m
    
    % FoS
    FoSs = 3; % FoS of the bolts
   
    
%Frequency Calculation    
    
Izz = 2.022;
Iyy = 1.293;
Ixx = 0.795;

R = 0.2688831;